/*-
 * Copyright (C) @BABOLO  2007 Nov 09
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pgob.h,v 1.10 2007/12/11 13:33:52 babolo Exp $
 */

#define PREG(CMD,REG) ( (pgoblin.p[REG].bin < 0)                                                     \
                      ? (pgoblin.a[CMD].flags >> ~pgoblin.p[REG].bin) & pgoblin.p[REG].mask          \
                      : pgoblin.p[REG].bin                                                           \
                      )
#define ERROUT(A,B) {ex = (A); errno = (B); goto out;}

/*    */
#define PGO_COUT    0
#define PGO_CCTL    1
#define PGO_CIN     2
#define PGO_CCON    3
#define PGO_CJOB    4
#define PGO_CSTY    5
#define PGO_CCPY    6
#define PGO_MAXR    7

#define IO_RG0      (options->io[0])
#define IO_OUT      (r[PGO_COUT].g.io)
#define IO_CTL      (r[PGO_CCTL].g.io)
#define IO_IN       (r[PGO_CIN].g.io)
#define IO_CPY      (r[PGO_CCPY].g.io)
#define R_CONN      (r[PGO_CCON].g.c)
#define CH_OUT      (r[PGO_COUT].c)
#define CH_CTL      (r[PGO_CCTL].c)
#define CH_IN       (r[PGO_CIN].c)
#define CH_CON      (r[PGO_CCON].c)
#define CH_JOB      (r[PGO_CJOB].c)
#define CH_STY      (r[PGO_CSTY].c)

#define PGOBLIN_BUFSIZE   8192
#define PGOBLIN_BUFMULT   2
#define PGOBLIN_RAWIOBUFL 1

#define PQEXEC(RESULT, QUERY, CONDITION, CCODE, RCONN) {                                             \
    ifBLIN_QV5(options->flags) fprintf(stderr, "PQexec: %s\n", (char*)(QUERY));                      \
    (RESULT) = PQexec(RCONN, (QUERY));                                                               \
    if  (!(RESULT)) {                                                                                \
        ifBLIN_QV1(options->flags) warnx("result is absent - fatal error.\n");                       \
        return(CCODE);                                                                               \
    }                                                                                                \
    ifBLIN_QV5(options->flags) fprintf(stderr, "PQresultStatus %d\n", PQresultStatus(RESULT));       \
    if  (PQresultStatus(RESULT) != (CONDITION)) {                                                    \
        if  (PQresultStatus(RESULT) == PGRES_FATAL_ERROR) {                                          \
            ifBLIN_QV1(options->flags) warnx("PQexec failed: %s", PQresultErrorMessage(RESULT));     \
            return(CCODE);                                                                           \
        } else if ((CONDITION) == PGRES_COMMAND_OK && PQresultStatus(RESULT) == PGRES_TUPLES_OK) {   \
            ifBLIN_QV2(options->flags) warnx("PQexec wait for COMMAND_OK but received TUPLES_OK");   \
        } else ifBLIN_QV1(options->flags) {                                                          \
            warnx("PQexec wait for %d but received %d", (CONDITION), PQresultStatus(RESULT));        \
            return(CCODE);                                                                           \
}   }   }

/* Do not use style! Any style must be NULL */
typedef struct pgoblin_style {
    char *tbeg;
    char *tend;
    char *rbeg;
    char *rmed;
    char *rend;
    char *cbeg;
    char *cmed;
    char *cend;
} pgoblin_style;

int      pgoblin_shurecon __P((pgoblin_main *options, int r));
int        pgoblin_listen __P((pgoblin_main *options, pgoblin_r *r));
int         pgoblin_begin __P((pgoblin_main *options, pgoblin_r *r));
int           pgoblin_end __P((pgoblin_main *options, pgoblin_r *r));
int       pgoblin_perform __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_echo __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_file __P((pgoblin_main *options, pgoblin_r *r));
int           pgoblin_cat __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_pipe __P((pgoblin_main *options, pgoblin_r *r));
int         pgoblin_close __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_exec __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_fork __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_wait __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_exit __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_trap __P((pgoblin_main *options, pgoblin_r *r));
int          pgoblin_call __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_return __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_copyin __P((pgoblin_main *options, pgoblin_r *r));
int       pgoblin_copyout __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_binsel __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_strsel __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_binpre __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_select __P((pgoblin_main *options, pgoblin_r *r));
int       pgoblin_display __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getstr __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getarg __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getenv __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getget __P((pgoblin_main *options, pgoblin_r *r));
int       pgoblin_getpost __P((pgoblin_main *options, pgoblin_r *r));
int       pgoblin_getproc __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getjob __P((pgoblin_main *options, pgoblin_r *r));
int        pgoblin_getspq __P((pgoblin_main *options, pgoblin_r *r));
